#include <stdio.h>
#include <ctype.h>
#include "dbcs.h"
#if SJIS
#include "sjis.h"
#endif

char *
lastchar(char *str)
{
    unsigned char *p = (unsigned char *)str;
    unsigned char *last = p;

    while (*p) {
	last = p;
	if (isdbcschar(*p)) {
	    p++;
	}
	p++;
    }

    return (char *)last;
}

char *
jstrchr(const char *str, int c)
{
  const unsigned char *p = str;

  while (*p) {
    if (*p == c)
      return (char *)p;
    else if (isdbcschar(*p) && p[1])
      p += 2;
    else
      p++;
  }
  return NULL;
}

int
jstrnicmp(const char *s1, const char *s2, size_t n)
{
  const unsigned char *p1 = s1, *p2 = s2;
  while (n > 0) {
    if (isdbcschar(*p1)) {
      if (*p1 - *p2 != 0)
	return *p1 - *p2;
      if (n > 1) {
	if (p1[1] - p2[1] != 0)
	  return p1[1] - p2[1];
	if (p1[1] == 0)
	  return 0;
      } else
	return 0;
      n -= 2; p1 += 2; p2 +=2;
    } else {
      int dif;
#if SJIS
      if (issjiskana(*p1))
	dif = *p1 - *p2;
      else
#endif
      dif = tolower(*p1) - tolower(*p2);
      if (dif != 0 || *p1 == 0)
	return dif;
      n--; p1++; p2++;
    }
  }
  return 0;
}

int
jstricmp(const char *s1, const char *s2)
{
  const unsigned char *p1 = s1, *p2 = s2;
  for (;;) {
    if (isdbcschar(*p1)) {
      if (*p1 - *p2 != 0)
	return *p1 - *p2;
      if (*p1 - *p2 != 0)
        return *p1 - *p2;
      if (*p1 == 0)
        return 0;
      p1 += 2; p2 +=2;
    } else {
      int dif;
#if SJIS
      if (issjiskana(*p1))
	dif = *p1 - *p2;
      else
#endif
      dif = tolower(*p1) - tolower(*p2);
      if (dif != 0 || *p1 == 0)
	return dif;
      p1++; p2++;
    }
  }
}
